=== roms/u-boot/arch/arm/cpu/armv7/iproc-common/Makefile ===
# SPDX-License-Identifier: GPL-2.0+
#
# Copyright 2014 Broadcom Corporation.

obj-y	+= armpll.o
obj-y	+= hwinit-common.o
obj-y	+= timer.o
