=== debian/changelog ===
qemu (1:8.2.2+ds-0ubuntu1) noble; urgency=medium

  * Merge version 8.2.2 from upstream. (LP: #2061005).  Cherry-picks from
    Debian:
    - d/p/ui-clipboard-mark-type-as-not-available-when-no-data-CVE-2023-6683.patch:
      Remove patch; included upstream.
    - d/control: clarify qemu-system-gui description: this is not a
      management gui for qemu
    - d/rules: stop qemu-system-${arch} packages from providing
      themselves (#1063233)
    - d/control{,-in}: Fix typo on qemu-system-gui description.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Fri, 12 Apr 2024 18:13:51 -0400

qemu (1:8.2.1+ds-1ubuntu9) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:20:15 +1100

qemu (1:8.2.1+ds-1ubuntu8) noble; urgency=medium

  * d/p/u/lp2012763-maxcpus-too-low.patch: Actually set the max_cpus
    property of the new Mantic machine types. (LP: #2012763)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 25 Mar 2024 14:58:39 -0400

qemu (1:8.2.1+ds-1ubuntu7) noble; urgency=medium

  * d/p/u/lp2012763-maxcpus-too-low.patch: Bump max_cpus to 1024 on
    Jammy amd64 machine types.  (LP: #2012763)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 18 Mar 2024 16:48:22 -0400

qemu (1:8.2.1+ds-1ubuntu6) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:16:54 +0000

qemu (1:8.2.1+ds-1ubuntu5) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:31:21 +0000

qemu (1:8.2.1+ds-1ubuntu4) noble; urgency=medium

  * No-change rebuild against libgnutls30t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 10 Mar 2024 02:11:43 +0000

qemu (1:8.2.1+ds-1ubuntu3) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:54:00 +0000

qemu (1:8.2.1+ds-1ubuntu2) noble; urgency=medium

  * d/p/u/lp-2055003-*: Properly initialize max_cpus limit to
    SPAPR_IRQ_NR_IPIS, fixing a segfault on ppc64el. (LP: #2055003)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 26 Feb 2024 15:32:25 -0500

qemu (1:8.2.1+ds-1ubuntu1) noble; urgency=medium

  * Merge with Debian unstable (LP: #2051883, #2049703). Remaining changes:
    - qemu-kvm to systemd unit
      - d/qemu-kvm-init: script for QEMU KVM preparation modules, ksm,
        hugepages and architecture specifics
      - d/qemu-system-common.qemu-kvm.service: systemd unit to call
        qemu-kvm-init
      - d/qemu-system-common.install: install helper script
      - d/qemu-system-common.qemu-kvm.default: defaults for
        /etc/default/qemu-kvm
      - d/rules: call dh_installinit and dh_installsystemd for qemu-kvm
    - Distribution specific machine type
      (LP 1304107 1621042 1776189 1761372 1761372 1776189)
      - d/p/ubuntu/define-ubuntu-machine-types.patch: define distro machine
        types containing release versioned machine attributes
      - Add an info about -hpb machine type in debian/qemu-system-x86.NEWS
      - ubuntu-q35 alias added to auto-select the most recent q35 ubuntu type
    - Enable nesting by default
      - d/p/ubuntu/enable-svm-by-default.patch: Enable nested svm by default
        in qemu64 on amd
        [ No more strictly needed, but required for backward compatibility ]
    - tolerate ipxe size change on migrations to >=18.04 (LP 1713490)
      - d/p/ubuntu/pre-bionic-256k-ipxe-efi-roms.patch: old machine types
        reference 256k path
      - d/control-in: depend on ipxe-qemu-256k-compat-efi-roms to be able to
        handle incoming migrations from former releases.
    - Ease the use of module retention on upgrades (LP 1913421)
      - debian/qemu-block-extra.postinst: enable mount unit on install/upgrade
    - Remaining GCC-12 FTBFS (LP 1988710 + LP 1921664)
      + d/p/u/qboot-Disable-LTO-for-ELF-binary-build-step.patch:
        fix qboot FTBFS with LTO
    - d/rules: Enable/disable extra features on microvm
      variant. (LP #2045594)
    - Move glusterfs storage driver to Universe in a new package
      (LP #2045063):
      + d/control{,-in}: new package qemu-block-supplemental for drivers
        we want in Universe
      + d/rules: we only want block-gluster.so in the new
        qemu-block-supplemental package. Adjust dynamically-created
        maintainer scripts for qemu-block-extra and -supplemental.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 07 Feb 2024 13:01:14 -0500

qemu (1:8.2.0+ds-4ubuntu2) noble; urgency=medium

  * Move glusterfs storage driver to Universe in a new package
    (LP: #2045063):
    - d/control{,-in}: new package qemu-block-supplemental for drivers
      we want in Universe
    - d/rules: we only want block-gluster.so in the new
      qemu-block-supplemental package. Adjust dynamically-created
      maintainer scripts for qemu-block-extra and -supplemental.

 -- Andreas Hasenack <andreas@canonical.com>  Fri, 02 Feb 2024 14:07:00 -0300
